<template>
  <div class="container">
    <div :class="{
      'input-container': true, 
      'border-bottom-animation': true, 
      'border-bottom-animation--show': isFocused, 
      'border-bottom-animation--error': error,
      dense: dense
      }">
      <textarea 
        :class="{input: true, error: error, dense: dense, dark: dark, ltr: ltr}"
        :id="id"
        :value="getValue"
        ref="input"
        autocomplete="off" 
        autocorrect="off" 
        spellcheck="false" 
        maxlength="524288"
        @focus="onFocus"
        @input="onInput"
        @blur="onBlur"
        >
      </textarea>
      <label :for="id" :class="{label: true, 'label--floated': isLabelFloated, 'label--colored': isFocused, 'label--error': error, dense: dense}">{{label}}</label>
      <div v-if="$slots.append" class="append">
        <slot name="append"></slot>
      </div>
    </div>
    <div class="bottom-line" v-if="helper || error">
      <div class="helper-text" v-if="helper && !error">{{helper}}</div>
      <div class="error-text" v-if="error">{{error}}</div>
    </div>
  </div>
</template>

<script>
import numeral from "numeral";

export default {
  name: 'TextField',
  data() {
    return {
      isFocused: false
    }
  },
  props: {
    value: {
      type: String,
      default: ""
    },
    helper: {
      type: String,
      default: ""
    },
    dark: {
      type: Boolean,
      default: false
    },
    error: {
      type: String,
      default: ""
    },
    inputType: {
      type: String,
      default: 'text'
    },
    id: {
      type: String,
      required: true
    },
    label: {
      type: String,
      required: true
    },
    dense: {
      type: Boolean,
      default: false
    },
    price: {
      type: Boolean,
      default: false
    },
    ltr: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    onFocus() {
      this.isFocused = true;
    },
    onBlur() {
      this.isFocused = false;
    },
    onInput(e) {
      if (!this.price) {
        this.$emit('input', this.$refs.input.value);
      } else {
        const num = numeral(this.$refs.input.value);
        console.log(num)
        if (num === null) {
          this.$emit('input', '');
        } else {

        }
        const value = String(num.value());
        console.log(value)
        this.$emit('input', value);
      }
    }
  },
  computed: {
    isLabelFloated() {
      return this.isFocused || this.value ? true : false;
    },
    getValue() {
      return this.price && this.value ? numeral(this.value).format("0,0") : this.value;
    }
  }
}
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

.input-container
  border-radius 4px 4px 0 0
  display flex
  flex-direction column 
  position relative
  height 18.5rem
  overflow hidden
  &.dense
    height 4.3rem


.input 
  width 100%
  height 100%
  resize none
  padding 2.2rem 1.6rem .5rem
  font-family inherit 
  font-size $font-size
  border none
  outline none
  border-bottom 1px solid rgba($white, .4)
  color $white
  background-color rgba(#DCDCDC, .01)
  direction rtl
  &:hover
    background-color rgba(#DCDCDC, .05)
    border-bottom 1px solid rgba($white, .8)
  &:focus
    background-color rgba(#DCDCDC, .1)
  &.error
    border-bottom 1px solid rgba($error, 1)
  &.dense
    padding: 2.2rem 1.6rem 1rem;
    font-size 1.4rem
  &.dark
    border-bottom 1px solid rgba($black, .15)
    background-color rgba(#DCDCDC, .2)
    color $black
    &:hover
      background-color rgba(#DCDCDC, .35)
      border-bottom 1px solid rgba($black, .2)
    &:focus
      background-color rgba(#DCDCDC, .5)
  &.ltr
    direction ltr
    text-align right

.label
  position absolute
  transition transform 150ms cubic-bezier(0.4, 0, 0.2, 1),color 150ms cubic-bezier(0.4, 0, 0.2, 1);
  transform-origin right top
  right 1.6rem
  top 1.6rem
  font-size $font-soze
  font-weight 300
  cursor text
  &--floated
    transform scale(.7) translateY(-70%)
    font-weight 400
    &.dense
      transform scale(.7) translateY(-50%)
  &--colored 
    color $primary
  &--error
    color $error
  &.dense
    font-size 1.4rem
    top .9rem

.border-bottom-animation
  &::after
    display block
    content ""
    height 2px
    background-color $primary
    z-index 2
    width 100%
    position absolute
    bottom 0
    left 50%
    transform translateX(-50%) scaleX(0)
    transition transform .2s ease-out
  &--show
    &::after
      transform translateX(-50%) scaleX(1)
  &--error::after
    background-color $error
  &.dense
    &::after
      height 1px

.bottom-line
  padding .5rem 1.6rem
  display flex
  direction rtl
  font-size 1.2rem;
  font-weight 400

.helper-text
  color rgba($black, .8)

.error-text
  color $error

.append
  position absolute
  left .5rem
  top 50%
  transform translateY(-50%)
  display flex
  align-items center
</style>

